; ShineInHex.asm

.386
.model flat,stdcall
option casemap:none

; Options
;STATIC_TABLE		equ	1

; Includes
include ShineInHex.inc

.code

DllEntry proc public hIns:HINSTANCE, reason:DWORD, reserved1:DWORD

	push	hIns
	pop	hInstance
	.if	reason==DLL_PROCESS_ATTACH
		invoke	ShineInHexInit
	.elseif reason==DLL_PROCESS_DETACH
		invoke UnregisterClass, ADDR classname, hInstance
	.endif
	mov    eax,TRUE
	ret

DllEntry Endp

ShineInHexInit	Proc
	invoke	CreateTextTable
	invoke	CreateClass
	ret
ShineInHexInit	EndP

CreateTextTable	Proc	uses esi edi

	mov	edi,o hexlook
	xor	ecx,ecx
	mov	esi,'  00'
	.While	cx<=0FFh
		mov	[edi],esi	; "00  "
		xor	eax,eax
		mov	al,cl
		db	0D4h,010h	;aam	16
		lea	edx,[eax+7676h]
		shr	edx,4
		and	edx,909h
		lea	eax,[eax+edx+2f2fh]
		xchg	al,ah
		mov	[edi],ax	; Store hex
		add	edi,4		; Next
		inc	cx
	.EndW
	; Fill spaces
	mov	edi,o hexspace
	mov	ecx,3*16
	mov	eax,'    '	; spaces
	rep	stosd
	
	mov	D[hex_nl],0A0Dh
	ret
CreateTextTable	EndP

CreateClass proc
	LOCAL  wc:WNDCLASSEX

	mov	   wc.cbSize,      SIZEOF WNDCLASSEX
	mov    wc.style,       CS_GLOBALCLASS+CS_SAVEBITS+CS_DBLCLKS
	mov	   wc.lpfnWndProc, OFFSET ShineInHexProc
	mov    wc.cbClsExtra,  0
	mov	   wc.cbWndExtra,  0
	push   hInstance
	pop	   wc.hInstance
	mov	   wc.hbrBackground, 0
	mov	   wc.lpszMenuName,  0
	mov	   wc.lpszClassName, OFFSET classname
	mov	   eax, 0
	mov	   wc.hIcon,   eax
	mov	   wc.hIconSm, eax
	invoke LoadCursor, 0, IDC_ARROW
	mov	   wc.hCursor, eax
	invoke RegisterClassEx, ADDR wc
	ret

CreateClass endp

ShineInHexProc proc hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	LOCAL hexbuf[16]:BYTE
	LOCAL buf   [32]:BYTE
	LOCAL counter:DWORD
	LOCAL offs_t :DWORD
	LOCAL offs_l :DWORD
	LOCAL f_old  :DWORD
	LOCAL dc     :DWORD
	LOCAL ps   :PAINTSTRUCT
	LOCAL sinfo:SCROLLINFO
	LOCAL rc   :RECT
	LOCAL pt   :POINT
	LOCAL size_:SIZEX

	mov		eax, uMsg
	.if eax==WM_CREATE
		push	edi
		mov	edi,o hex_dm
		assume	edi: ptr HEX_DIM
		push	edi
		mov	ecx,sizeof HEX_DIM/4
		xor	eax,eax
		rep	stosd
		pop	edi
		
		mov	[edi].bk_color1,              0ffffffh
		mov	[edi].bk_color2,              0ffffffh
		mov	[edi].bk_color3,              0ffffffh
		mov	[edi].text_color1,            0ff8080h
		mov	[edi].text_color2,            0800000h
		mov	[edi].text_color3,            0008000h
		mov	[edi].sel_bk_color2,          0ff8080h
		mov	[edi].sel_bk_color3,          0808000h
		mov	[edi].sel_text_color2,        0c0ffc0h
		mov	[edi].sel_text_color3,        0ffffffh
		mov	[edi].active_char_bk_color,   00000ffh
		mov	[edi].active_char_text_color, 0ffffffh
		mov	eax, hWin
		mov	[edi].hWnd, eax
		
		invoke CreateFontIndirect, ADDR lf1
		mov	dword ptr [lf_choose+ 0], eax
		invoke CreateFontIndirect, ADDR lf2
		mov	dword ptr [lf_choose+ 4], eax
		invoke CreateFontIndirect, ADDR lf3
		mov	dword ptr [lf_choose+ 8], eax
		
		invoke CreatePopupMenu
		mov	hex_popup, eax
		mov	eax, offset hexlook
		mov	[edi].pointer, offset hexspace
		mov	[edi]._size, 1
		mov	[edi].view_lenx, 8
		pop	edi
		assume	edi: nothing
		invoke AppendMenu,  hex_popup, MF_STRING, 13000, ADDR menu_copy_text
		invoke AppendMenu,  hex_popup, MF_STRING, 13001, ADDR menu_copy_hex
		invoke AppendMenu,  hex_popup, MF_STRING, 13002, ADDR menu_find
		invoke AppendMenu,  hex_popup, MF_STRING, 13003, ADDR menu_select
		
		invoke SendMessage, hWin, HEXM_SETFONT, 0, 0
		
	.elseif eax==HEXM_SETFONT
		mov    eax, wParam
		.if eax > 2
			xor    eax, eax
			ret
		.endif
		mov    eax, DWORD PTR [lf_choose+eax*4]
		mov    hex_dm.font, eax
		invoke GetDC, hWin
		mov    dc, eax
		invoke SelectObject, dc, hex_dm.font
		;............................
		invoke GetTextExtentPoint32, dc, ADDR measure_x, 52, ADDR size_
		xor    edx, edx
		mov    eax, size_.cx_
		mov    ecx, 26
		div    ecx
		add    eax, 1
		shr    eax, 1
		;............................
		mov    hex_dm.fon_cx, eax
		shl    eax, 3
		mov    hex_dm.rc1.right, eax
		add    eax, 4
		mov    hex_dm.rc2.left, eax
		mov    hex_dm.sel_rc.left, eax
		mov    eax, size_.cy_
		mov    hex_dm.fon_cy, eax
		;------
		mov    eax, hex_dm.fon_cx
		lea    eax, [eax+eax*2]
		mul    hex_dm.view_lenx
		add    eax, hex_dm.rc2.left
		mov    hex_dm.rc2.right, eax
		add    eax, 4
		mov    hex_dm.rc3.left, eax
		;------
		mov    eax, hex_dm.fon_cx
		mul    hex_dm.view_lenx
		add    eax, hex_dm.rc3.left
		mov    hex_dm.rc3.right, eax
		;------
		invoke GetClientRect, hWin, ADDR rc
		mov    eax, rc.bottom
		xor    edx, edx
		div    hex_dm.fon_cy
		mov    hex_dm.view_leny, eax
		;------
		mul    hex_dm.fon_cy
		mov    hex_dm.rc1.bottom, eax
		mov    hex_dm.rc2.bottom, eax
		mov    hex_dm.rc3.bottom, eax
		invoke ReleaseDC, hWin, dc
		invoke SendMessage, hWin, WM_SETFOCUS, 0, 0
		mov    sinfo.fMask, 0
		jmp    @resize
		
	.elseif eax==HEXM_SETVIEW1COL || eax==HEXM_SETVIEW2COL || eax==HEXM_SETVIEW3COL 
		mov    ecx, wParam
		mov    edx, lParam
		.if eax==HEXM_SETVIEW1COL
			mov    hex_dm.bk_color1,   ecx
			mov    hex_dm.text_color1, edx
		.elseif eax==HEXM_SETVIEW2COL
			mov    hex_dm.bk_color2,   ecx
			mov    hex_dm.text_color2, edx
		.elseif eax==HEXM_SETVIEW3COL
			mov    hex_dm.bk_color3,   ecx
			mov    hex_dm.text_color3, edx
		.endif
		invoke InvalidateRect, hWin, 0, 0
		
	.elseif eax==HEXM_SETVIEW2SELCOL || eax==HEXM_SETVIEW3SELCOL 
		mov    ecx, wParam
		mov    edx, lParam
		.if eax==HEXM_SETVIEW2SELCOL
			mov    hex_dm.sel_bk_color2,   ecx
			mov    hex_dm.sel_text_color2, edx
		.elseif eax==HEXM_SETVIEW3SELCOL
			mov    hex_dm.sel_bk_color3,   ecx
			mov    hex_dm.sel_text_color3, edx
		.endif
		invoke InvalidateRect, hWin, 0, 0

	.elseif eax==HEXM_UNSETPOINTER
		mov    hex_dm.pointer, offset hexspace
		mov    hex_dm._size, 1

	.elseif eax==HEXM_SETPOINTER
		xor    eax, eax
		mov    hex_dm.sel_start,  eax
		mov    hex_dm.sel_end,    eax
		mov    hex_dm.vscrollpos, eax
		mov    sinfo.nPos,        eax
		mov    sinfo.fMask,       SIF_POS
		mov    eax, wParam
		mov    ecx, lParam
		mov    hex_dm.pointer, eax
		mov    hex_dm._size, ecx
		invoke SendMessage, hWin, WM_SETFOCUS, 0, 0
		invoke GetClientRect, hWin, ADDR rc
	@resize:
		mov    hex_dm.view_lenx, 1
		mov    hex_dm.view_leny, 1
		
		invoke InvalidateRect, hWin, 0, 0
			
		mov    ecx, rc.bottom
		shl    ecx, 16
		mov    eax, rc.right
		mov    cx,  ax
		mov    lParam, ecx
		jmp    @sizing
		
	.elseif eax==HEXM_SETOFFSET
		mov    eax, wParam
		mov    hex_dm._start, eax
		invoke InvalidateRect, hWin, 0, 0

	.elseif eax==HEXM_SETACTIVECHARCOL
		mov    ecx, wParam
		mov    edx, lParam
		mov    hex_dm.active_char_bk_color,   ecx
		mov    hex_dm.active_char_text_color, edx
		invoke InvalidateRect, hWin, 0, 0
		
	.elseif eax==HEXM_SETSEL
		mov    eax, wParam
		sub    eax, hex_dm._start
		mov    hex_dm.sel_start, eax
		xor    edx, edx
		div    hex_dm.view_lenx
		mov    ecx, hex_dm._nMax
		sub    ecx, eax
		mov    edx, hex_dm._nMax
		.if ecx < hex_dm.view_leny && edx > hex_dm.view_leny
			mov    ecx, hex_dm._nMax
			sub    ecx, hex_dm.view_leny
			inc    ecx
			mov    eax, ecx
		.endif
		.if edx > hex_dm.view_leny
			mov    hex_dm.vscrollpos, eax
			invoke SetScrollPos, hWin, SB_VERT, eax, 1
		.endif	
		;-------------------
		mov    eax, lParam
		sub    eax, hex_dm._start
		mov    hex_dm.sel_end,   eax
		invoke InvalidateRect, hWin, 0, 0
		
	.elseif eax==WM_CHAR
		mov    eax, wParam
		.if	al >= 30h && al <= 39h || al >= 41h && al <= 46h || al >= 61h && al <= 66h
			mov    edi, hex_dm.pointer
			mov    ecx, hex_dm.sel_start
			mov    edx, hex_dm.sel_end
			.if ecx > edx
				add    edi, edx
				xchg   ecx, edx
				dec    edx
			.elseif ecx < edx
				add    edi, ecx
				dec    edx
			.else
				add    edi, ecx
			.endif
			xor    ebx, ebx
			.if al >= 30h && al <= 39h
				sub    al, 30h
			.elseif al >= 41h && al <= 46h
				sub    al, 37h
			.elseif al >= 61h && al <= 66h
				sub    al, 57h
			.endif
		@next_char:	
			mov    bl, byte ptr [edi]
			.if hex_dm.byte_nr == 0
				and    bl, 00fh
				shl    al, 4
				.if edx==ecx
					inc    hex_dm.byte_nr
				.endif
			.elseif hex_dm.byte_nr == 1
				and    bl, 0f0h
				or     bl, al
				mov    byte ptr [edi], bl				
				.if edx > ecx
					dec    edx
					inc    edi
					jmp    @next_char
				.endif
				invoke InvalidateRect, hWin, 0, 0
				mov    ecx, hex_dm.sel_start
				mov    edx, hex_dm.sel_end
				.if ecx == edx
					mov    wParam, VK_RIGHT
					jmp    @right
				.else
					mov    hex_dm.byte_nr, 0
					jmp    @selection
				.endif
			.endif
			or     bl, al
			mov    byte ptr [edi], bl
			.if edx > ecx
				dec    edx
				inc    edi
				shr    al, 4
				jmp    @next_char
			.endif
			invoke InvalidateRect, hWin, 0, 0
		.endif
	@selection:	
		
	.elseif eax==WM_KEYDOWN
		mov    eax, wParam
		.if eax > 20h && eax < 29h
			mov    ecx, hex_dm.sel_start
			mov    edx, hex_dm.sel_end
			.if ecx < edx || ecx > edx
				mov     hex_dm.sel_start, edx
				mov     hex_dm.sel_end,   edx
			.endif
		.endif
	@right:
		mov    eax, wParam
		.if eax == VK_RIGHT || eax == VK_LEFT
			mov    hex_dm.byte_nr, 0
			.if eax == VK_RIGHT
				mov    eax, hex_dm.view_leny
				mov    ecx, hex_dm.view_lenx
				mov    edx, hex_dm._size
				dec    edx
				cmp    hex_dm.sel_end, edx
				jz     @skip
				;???
				mov    eax, hex_dm.sel_end
				xor    edx, edx
				div    hex_dm.view_lenx
				sub    eax, hex_dm.vscrollpos
				inc    eax
				cmp    eax, hex_dm.view_leny
				;???
				jnz    @no_new_line
				dec    eax
				add    eax, hex_dm.vscrollpos
				mul    hex_dm.view_lenx
				mov    ecx, hex_dm.sel_end
				sub    ecx, eax
				mov    eax, hex_dm.view_lenx
				dec    eax
				cmp    ecx, eax
				jnz    @no_new_line
				invoke SendMessage, hWin, WM_VSCROLL, SB_LINEDOWN, 0
			  @no_new_line:
				inc    hex_dm.sel_start
				inc    hex_dm.sel_end
			.else
				mov    eax, hex_dm.view_lenx
				xor    ecx, ecx
				cmp    hex_dm.sel_end, ecx
				jz     @skip
				;???
				mov    eax, hex_dm.sel_end
				xor    edx, edx
				div    hex_dm.view_lenx
				sub    eax, hex_dm.vscrollpos
				cmp    eax, 0
				;???
				jnz    @no_prev_line
				mov    eax, hex_dm.vscrollpos
				mul    hex_dm.view_lenx
				mov    ecx, hex_dm.sel_end
				sub    ecx, eax
				mov    eax, hex_dm.view_lenx
				cmp    ecx, 0
				jnz    @no_prev_line
				invoke SendMessage, hWin, WM_VSCROLL, SB_LINEUP, 0
			  @no_prev_line:	
				dec    hex_dm.sel_start
				dec    hex_dm.sel_end
			.endif
		.elseif eax == VK_UP || eax == VK_DOWN
			.if eax == VK_UP
				mov    eax, hex_dm.view_lenx
				cmp    hex_dm.sel_end, eax
				jb     @skip
				;???
				mov    eax, hex_dm.sel_end
				xor    edx, edx
				div    hex_dm.view_lenx
				sub    eax, hex_dm.vscrollpos
				cmp    eax, 0
				;???
				jg     @dec_y_pos
				invoke InvalidateRect, hWin, 0, 0
				invoke SendMessage, hWin, WM_VSCROLL, SB_LINEUP,   0
				jmp    @skip_a
			  @dec_y_pos:
				invoke InvalidateRect, hWin, ADDR hex_dm.sel_rc, 0
			  @skip_a:
				mov    ecx, hex_dm.view_lenx
				sub    hex_dm.sel_start, ecx
				sub    hex_dm.sel_end,   ecx
			.else
				mov    ecx, hex_dm.view_leny
				mov    eax, hex_dm._size
				sub    eax, hex_dm.view_lenx
				cmp    hex_dm.sel_end, eax
				jge    @skip
				;???
				mov    eax, hex_dm.sel_end
				xor    edx, edx
				div    hex_dm.view_lenx
				sub    eax, hex_dm.vscrollpos
				inc    eax
				cmp    eax, ecx
				;???
				jl     @inc_y_pos
				invoke InvalidateRect, hWin, 0, 0
				invoke SendMessage, hWin, WM_VSCROLL, SB_LINEDOWN, 0
				jmp    @skip_b
			  @inc_y_pos:
				invoke InvalidateRect, hWin, ADDR hex_dm.sel_rc, 0
			  @skip_b:	
				mov    ecx, hex_dm.view_lenx
				add    hex_dm.sel_start, ecx
				add    hex_dm.sel_end,   ecx
			.endif
			jmp    @skip
		.elseif eax == VK_PGDN
			mov    eax, hex_dm.view_lenx
			mov    edx, hex_dm.sel_end
			add    edx, eax
			cmp    edx, hex_dm._size
			jae    @pgdn
			mov    ecx, hex_dm.view_leny
			mul    ecx
			mov    edx, hex_dm.sel_end
			add    edx, eax
			cmp    edx, hex_dm._size
			jae    @F
			add    hex_dm.sel_start,  eax
			add    hex_dm.sel_end,    eax
			invoke SendMessage, hWin, WM_VSCROLL, SB_PAGEDOWN, 0
			jmp    @pgdn
		  @@:
			mov    eax, hex_dm._nMax
			sub    eax, hex_dm.view_leny
			inc    eax
			mov    hex_dm.vscrollpos, eax
			mov    eax, hex_dm.sel_end
			xor    edx, edx 
			div    hex_dm.view_lenx
			mov    ecx, hex_dm._nMax
			sub    ecx, eax
			mov    eax, ecx
			mul    hex_dm.view_lenx
			mov    ecx, hex_dm._size
			mov    edx, hex_dm.sel_end
			add    edx, eax
			cmp    edx, ecx
			jb     @F
			dec    ecx
			mov    hex_dm.sel_start,  ecx
			mov    hex_dm.sel_end,    ecx
			invoke SetScrollPos, hWin, SB_VERT, hex_dm._nMax, 1
			jmp    @pgdn
		  @@:	
			add    hex_dm.sel_start,  eax
			add    hex_dm.sel_end,    eax
			invoke SetScrollPos, hWin, SB_VERT, hex_dm._nMax, 1
		  @pgdn:	
		.elseif eax == VK_PGUP
			mov    eax, hex_dm.view_lenx
			mov    edx, hex_dm.sel_end
			sub    edx, eax
			cmp    edx, 0
			jl     @pgup
			mov    ecx, hex_dm.view_leny
			mul    ecx
			mov    edx, hex_dm.sel_end
			sub    edx, eax
			cmp    edx, 0
			jl     @F
			sub    hex_dm.sel_start,  eax
			sub    hex_dm.sel_end,    eax
			invoke SendMessage, hWin, WM_VSCROLL, SB_PAGEUP, 0
			jmp    @pgup
		  @@:
			mov    eax, hex_dm.sel_end
			xor    edx, edx 
			div    hex_dm.view_lenx
			mov    hex_dm.vscrollpos, 0
			mul    hex_dm.view_lenx
			sub    hex_dm.sel_start,  eax
			sub    hex_dm.sel_end,    eax
			invoke SetScrollPos, hWin, SB_VERT, 0, 1 
		  @pgup:
		.elseif eax==VK_HOME || eax==VK_END
			.if eax==VK_HOME
				mov    ecx, hex_dm.view_lenx
				mov    eax, hex_dm.sel_end
				xor    edx, edx
				div    ecx
				cmp    edx, 0
				jz     @skip
				sub    hex_dm.sel_start, edx
				sub    hex_dm.sel_end,   edx
				mov    eax, 1
			.else
				mov    ecx, hex_dm.view_lenx
				mov    eax, hex_dm.sel_end
				inc    eax
				xor    edx, edx
				div    ecx
				cmp    edx, 0
				jz     @skip
				mov    eax, hex_dm.view_lenx
				sub    eax, edx
				add    hex_dm.sel_start, eax
				add    hex_dm.sel_end,   eax
				mov    eax, hex_dm.view_lenx
			.endif
		.endif
		invoke InvalidateRect, hWin, ADDR hex_dm.sel_rc, 0
	@skip:
		
	.elseif eax==WM_SETFOCUS
		invoke SetFocus,    hWin
		
	.elseif eax==WM_MOUSEACTIVATE
		invoke SetFocus, hWin
		mov    eax, MA_ACTIVATE
		ret
		
	.elseif eax==WM_VSCROLL
		mov    sinfo.cbSize,  sizeof SCROLLINFO
		mov    sinfo.fMask,   SIF_ALL
		invoke GetScrollInfo, hWin, SB_VERT, ADDR sinfo
		push   sinfo.nPos
		mov    eax, wParam
		and    eax, 0ffffh
		cmp    eax, SB_TOP
		je     top
		cmp    eax, SB_BOTTOM
		je     bottom
		cmp    eax, SB_LINEUP
		je     lineup
		cmp    eax, SB_LINEDOWN
		je     linedown
		cmp    eax, SB_PAGEUP
		je     pageup
		cmp    eax, SB_PAGEDOWN
		je     pagedown
		cmp    eax, SB_THUMBTRACK
		je     ttrack
		cmp    eax, SB_THUMBPOSITION
		je     ttrack
		mov    eax, 0
		ret
top:
		mov    eax, sinfo.nMin
		mov    sinfo.nPos, eax
		jmp    @F
bottom:
		mov    eax, sinfo.nMax
		mov    sinfo.nPos, eax
		jmp    @F
lineup:
		dec    sinfo.nPos
		jmp    @F
linedown:
		inc    sinfo.nPos
		jmp    @F
pageup:
		mov    eax, sinfo.nPage
		sub    sinfo.nPos, eax
		jmp    @F
pagedown:
		mov    eax, sinfo.nPage
		add    sinfo.nPos, eax
		mov    ecx, sinfo.nMax
		sub    ecx, sinfo.nPage
		inc    ecx
		cmp    sinfo.nPos, ecx
		jb     @F
		mov    sinfo.nPos, ecx
		jmp    @F
ttrack:
		mov    eax, sinfo.nTrackPos
		mov    sinfo.nPos, eax
@@:
		.if SDWORD PTR sinfo.nPos < 0
			mov sinfo.nPos, 0
		.endif
		mov    ecx, sinfo.nPos
		pop    eax
		sub    eax, ecx
		add    ecx, sinfo.nPage
		dec    ecx
		.if eax != 0 && ecx <= sinfo.nMax
			push   eax
			mov    eax, sinfo.nPos
			mov    hex_dm.vscrollpos, eax
			invoke SetScrollInfo, hWin, SB_VERT, ADDR sinfo, TRUE
			invoke MemCopy, ADDR hex_dm.rc3, ADDR rc, sizeof RECT
			mov    rc.left, 0
			mov    eax, hex_dm.rc1.bottom
			mov    rc.bottom, eax
			pop    eax
			mul    hex_dm.fon_cy
			mov    ecx, eax
			invoke ScrollWindowEx, hWin, 0, ecx, ADDR rc, ADDR rc, 0, 0, SW_INVALIDATE
		.endif
		
	.elseif eax==WM_MOUSEWHEEL
		mov	eax, wParam
		shr	eax, 16
		xor	ecx,ecx	; SB_LINEUP
		cmp	ax,cx	;0
		jge	@F
			inc	ecx	; SB_LINEDOWN
		@@:
		invoke SendMessage,hWin,WM_VSCROLL,ecx,0
		
	.elseif eax==WM_LBUTTONDOWN || eax==WM_LBUTTONUP || eax==WM_MOUSEMOVE && wParam == MK_LBUTTON
		.if eax==WM_LBUTTONDOWN
			mov    hex_set2, 0
		.endif
		mov    eax, lParam
		and    eax, 0ffffh
		.if eax >= hex_dm.rc2.left && hex_set2 == 0
			.if eax >= hex_dm.rc3.left
				sub    eax, hex_dm.rc3.left
				mov    ebx, hex_dm.fon_cx
				xor    edx, edx
				div    ebx
			.else
				sub    eax, hex_dm.rc2.left
				mov    ebx, hex_dm.fon_cx
				lea    ecx, [ebx+ebx*2]
				xor    edx, edx
				div    ecx
				shl    ebx, 1
			.endif
			.if edx > ebx
				inc eax
			.endif
			mov    edi, eax
			mov    eax, lParam
			shr    eax, 16
			mov    ecx, hex_dm.fon_cy
			xor    edx, edx
			div    ecx
			mov    ecx, hex_dm.view_lenx
			mul    ecx
			add    edi, eax
			mov    eax, hex_dm.vscrollpos
			mul    hex_dm.view_lenx
			add    edi, eax
			.if uMsg==WM_LBUTTONDOWN
				mov    hex_set1, 1
				mov    hex_set2, 0
				mov    hex_dm.sel_start, edi
				mov    hex_dm.sel_end,   edi
				invoke SetCapture, hWin
			.elseif uMsg==WM_LBUTTONUP
				mov    hex_set2, 1
				cmp    hex_dm.timer_direction, 0
				jnz    @F
				mov    hex_dm.sel_end, edi
			  @@:	
				invoke ReleaseCapture
				invoke KillTimer, hWin, 100
				mov    ecx, hex_dm._size
				cmp    hex_dm.sel_end, ecx
				jb     @no_size_over
				mov    hex_dm.sel_end, ecx
			  @no_size_over:
				mov    hex_dm.timer_direction, 0
				invoke InvalidateRect, hWin, ADDR hex_dm.sel_rc, 0
			.elseif uMsg==WM_MOUSEMOVE
				mov    eax, hex_dm.sel_end
				mov    ecx, lParam
				shr    ecx, 16
				.if ecx > 0F000h
					cmp    hex_dm.timer_direction, 0
					jnz    @F
					invoke SetTimer, hWin, 100, 20, 0
					mov    hex_dm.timer_direction, 1
					@@:
				.elseif ecx > hex_dm.rc1.bottom
					cmp    hex_dm.timer_direction, 0
					jnz    @F
					invoke SetTimer, hWin, 100, 20, 0
					mov    hex_dm.timer_direction, 2
					@@:
				.elseif eax != edi
					invoke KillTimer, hWin, 100
					mov    hex_dm.timer_direction, 0
					mov    hex_dm.sel_end, edi
					invoke InvalidateRect, hWin, ADDR hex_dm.sel_rc, 0
				.endif
			.endif			
		.endif
		
	.elseif eax==WM_TIMER
		.if hex_dm.timer_direction == 1
			mov    eax, hex_dm.sel_end
			mov    ecx, hex_dm.view_lenx
			sub    eax, ecx
			cmp    eax, 0
			jl     @F
			sub    hex_dm.sel_end, ecx
			invoke InvalidateRect, hWin, ADDR hex_dm.sel_rc, 0
			invoke SendMessage, hWin, WM_VSCROLL, SB_LINEUP, 0
		  @@:
		.elseif hex_dm.timer_direction == 2
			mov    eax, hex_dm.sel_end
			mov    ecx, hex_dm.view_lenx
			add    eax, ecx
			cmp    eax, hex_dm._size
			jge    @F
			add    hex_dm.sel_end,   ecx
			invoke InvalidateRect, hWin, ADDR hex_dm.sel_rc,   0
			invoke SendMessage, hWin, WM_VSCROLL, SB_LINEDOWN, 0
		  @@:
		.endif
	
	.elseif eax==WM_RBUTTONUP
		mov    ecx, hex_dm.sel_start
		sub    ecx, hex_dm.sel_end
		.if ecx==0
			mov edi, MF_GRAYED
		.else
			mov edi, MF_ENABLED
		.endif
		invoke EnableMenuItem, hex_popup, 13000, edi
		invoke EnableMenuItem, hex_popup, 13001, edi
		invoke GetCursorPos, ADDR pt
		invoke TrackPopupMenuEx, hex_popup, TPM_LEFTALIGN, pt.x, pt.y, hWin, 0
		
	.elseif eax==WM_COMMAND
		mov    eax, wParam
		.if eax==13000 || eax==13001
			invoke OpenClipboard, hWin
			invoke EmptyClipboard		
			mov    ebx, hex_dm.sel_start
			mov    ecx, hex_dm.sel_end
			.if ebx > ecx
				sub    ebx, ecx
				mov    ecx, ebx
			.else
				sub    ecx, ebx
			.endif
			shl    ecx, 1
			inc    ecx
			invoke GlobalAlloc, GMEM_MOVEABLE, ecx
			mov    hex_clip_copy, eax
			invoke GlobalLock, hex_clip_copy
			mov    hex_clip_point, eax
			cmp    eax, 0
			je     @exit
			mov    esi, hex_dm.pointer
			mov    edi, hex_clip_point
			mov    ecx, hex_dm.sel_start
			mov    edx, hex_dm.sel_end
			.if ecx > edx
				add    esi, edx
				sub    ecx, edx
			.else
				add    esi, ecx
				sub    edx, ecx
				mov    ecx, edx
			.endif
			.if wParam==13000
			@@:	
				cmp    ecx, 0
				jz     @F
				mov    al, byte ptr [esi]
				mov    byte ptr [edi], al
				inc    esi
				inc    edi
				dec    ecx
				jmp    @B
			@@:
			.else
				mov    ebx, offset hexlook
			@@:	
				xor    eax, eax
				cmp    ecx, 0
				jz     @F
				mov    al, byte ptr [esi]
				mov    dl, byte ptr [eax*4+ebx]
				mov    byte ptr [edi], dl
				inc    edi
				mov    dl, byte ptr [eax*4+ebx+1]
				mov    byte ptr [edi], dl
				inc    esi
				inc    edi
				dec    ecx
				jmp    @B
			@@:
			.endif
			mov    byte ptr [edi], 0
			invoke GlobalUnlock, hex_clip_copy
			invoke SetClipboardData, CF_TEXT, hex_clip_copy
			invoke CloseClipboard
		@exit:
			invoke GlobalFree, hex_clip_copy
		.elseif eax == 13002
			invoke DialogBoxParamW, hInstance, 666, hWin, ADDR DlgFind, 0
		.elseif eax == 13003
			invoke DialogBoxParam,  hInstance, 999, hWin, ADDR DlgSelect, 0
		.endif
		
	.elseif eax==WM_SIZE
	@sizing:
		mov    eax, lParam
		and    eax, 0ffffh
		;view_lenx = (XSize - 8 - foncx*8) / foncx*4
		sub     eax, 8
		mov     ecx, hex_dm.fon_cx
		shl     ecx, 3
		sub     eax, ecx
		shr     ecx, 1
		xor     edx, edx
		div     ecx
		.if hex_dm.view_lenx != eax && eax > 3
			mov    hex_dm.view_lenx, eax
			;------
			mov    eax, hex_dm.fon_cx
			lea    eax, [eax+eax*2]
			mov    ecx, hex_dm.view_lenx
			mul    ecx
			add    eax, hex_dm.rc2.left
			mov    hex_dm.rc2.right, eax
			add    eax, 4
			mov    hex_dm.rc3.left, eax
			;------
			mov    eax, hex_dm.fon_cx
			mov    ecx, hex_dm.view_lenx
			mul    ecx
			add    eax, hex_dm.rc3.left
			mov    hex_dm.rc3.right,    eax
			mov    hex_dm.sel_rc.right, eax
			invoke InvalidateRect, hWin, 0, 0
		.endif
		mov    eax, lParam
		shr    eax, 16
		xor    edx, edx
		div    hex_dm.fon_cy
		mov    ecx, eax
		mul    hex_dm.fon_cy
		mov    edx, hex_dm.view_leny
		.if ecx != edx
			mov    hex_dm.rc1.bottom, eax
			mov    hex_dm.rc2.bottom, eax
			mov    hex_dm.rc3.bottom, eax
			mov    hex_dm.sel_rc.bottom, eax
			mov    hex_dm.view_leny,  ecx
			mov    hex_dm.client_cy,  eax
			invoke InvalidateRect, hWin, 0, 0
		.endif
		mov    sinfo.cbSize, sizeof SCROLLINFO
		mov    sinfo.fMask, SIF_DISABLENOSCROLL+SIF_PAGE+SIF_RANGE
		mov    eax, hex_dm.view_leny
		mov    sinfo.nPage, eax
		mov    ecx, hex_dm.view_lenx
		mov    eax, hex_dm._size
		dec    eax
		xor    edx, edx
		div    ecx
		mov    sinfo.nMax,   eax
		mov    hex_dm._nMax, eax
		xor    ecx, ecx
		mov    sinfo.nMin, ecx
		invoke SetScrollInfo, hWin, SB_VERT, ADDR sinfo, 1
		invoke GetScrollPos,  hWin, SB_VERT
		mov    hex_dm.vscrollpos, eax
		
	.elseif eax==WM_PAINT
		invoke BeginPaint, hWin, ADDR ps
		invoke SelectObject, ps.hdc, hex_dm.font
		;---STAGE_1---------------------------
		invoke SetBkColor,   ps.hdc, hex_dm.bk_color1
		invoke SetTextColor, ps.hdc, hex_dm.text_color1
		mov    edi, hex_dm.rc1.top
		mov    esi, hex_dm.vscrollpos
	@@:
		mov    eax, esi
		mul    hex_dm.view_lenx
		mov    ecx, eax
		add    ecx, hex_dm._start
		invoke dw2hex, ecx, ADDR hexbuf
		invoke ExtTextOut, ps.hdc, hex_dm.rc1.left, edi, ETO_OPAQUE, 0, ADDR hexbuf, 8, 0
		inc    esi
		add    edi, hex_dm.fon_cy
		mov    eax, hex_dm.rc1.bottom
		cmp    edi, eax
		jb     @B
		;---STAGE_2---------------------------
		mov    offs_t, 0
		mov    eax, hex_dm.rc2.left
		mov    offs_l, eax
		mov    esi, offset hexlook
		mov    edi, hex_dm.pointer
		mov    eax, hex_dm.vscrollpos
		mul    hex_dm.view_lenx
		add    edi, eax
		mov    ecx, hex_dm._size
		sub    ecx, eax
		mov    counter, ecx
	@@:	
		xor    ecx, ecx
		mov    cl, byte ptr [edi]
		shl    ecx, 2
		add    ecx, esi
		mov    eax, edi
		sub    eax, hex_dm.pointer
		push   ecx
		mov    ebx, hex_dm.sel_start
		mov    ecx, hex_dm.sel_end
		.if eax == ebx && eax == ecx
			mov    eax, hex_dm.bk_color2
			xor    eax, 0ffffffh
			invoke SetBkColor,   ps.hdc, eax
			mov    eax, hex_dm.text_color2
			xor    eax, 0ffffffh
			invoke SetTextColor, ps.hdc, eax
		.elseif	eax >= ebx && eax < ecx || eax >= ecx && eax < ebx
			invoke SetBkColor,   ps.hdc, hex_dm.sel_bk_color2
			invoke SetTextColor, ps.hdc, hex_dm.sel_text_color2
		.else
			invoke SetBkColor,   ps.hdc, hex_dm.bk_color2
			invoke SetTextColor, ps.hdc, hex_dm.text_color2
		.endif
		pop   ecx
		invoke ExtTextOut, ps.hdc, offs_l, offs_t, ETO_OPAQUE, 0, ecx, 3, 0
		inc    edi
		mov    eax, hex_dm.fon_cx
		lea    eax, [eax+eax*2]
		add    offs_l, eax
		mov    ecx, hex_dm.rc2.right
		sub    ecx, eax
		.if offs_l > ecx
			mov eax, hex_dm.rc2.left
			mov offs_l, eax
			mov eax, hex_dm.fon_cy
			add offs_t, eax
		.endif
		dec    counter
		.if counter==0
			invoke SetBkColor, ps.hdc, hex_dm.bk_color2
			mov    eax, hex_dm.rc2.right
			sub    eax, offs_l
			xor    edx, edx
			div    hex_dm.fon_cx
			invoke ExtTextOut, ps.hdc, offs_l, offs_t, ETO_OPAQUE, 0, ADDR hexspace, eax, 0
		@fill_empty2:
			mov    ecx, hex_dm.rc2.bottom
			mov    eax, hex_dm.fon_cy
			add    offs_t, eax
			cmp    offs_t, ecx
			jge    @full2
			mov    ecx, hex_dm.view_lenx
			lea    ecx, [ecx+ecx*2]
			invoke ExtTextOut, ps.hdc, hex_dm.rc2.left, offs_t, ETO_OPAQUE, 0, ADDR hexspace, ecx, 0
			jmp    @fill_empty2
		@full2:
		.else
			mov    eax, hex_dm.rc2.bottom
			cmp    offs_t, eax
			jb @B
		.endif
		;---STAGE_3---------------------------
		mov    offs_t, 0
		mov    eax, hex_dm.rc3.left
		mov    offs_l, eax
		mov    edi, hex_dm.pointer
		mov    eax, hex_dm.vscrollpos
		mul    hex_dm.view_lenx
		add    edi, eax
		mov    esi, offset hex_byte
		mov    ecx, hex_dm._size
		sub    ecx, eax
		mov    counter, ecx
	@@:
		mov    cl, byte ptr [edi]
		.if	cl < 33 || (cl > 126 && cl<192)
			mov    cl, '.'
		.endif
		mov    byte ptr [esi], cl
		mov    eax, edi
		sub    eax, hex_dm.pointer
		mov    ebx, hex_dm.sel_start
		mov    ecx, hex_dm.sel_end
		.if eax >= ebx && eax < ecx || eax > ecx && eax <= ebx
			invoke SetBkColor,   ps.hdc, hex_dm.sel_bk_color3
			invoke SetTextColor, ps.hdc, hex_dm.sel_text_color3
		.elseif eax==ecx
			invoke SetBkColor,   ps.hdc, hex_dm.active_char_bk_color
			invoke SetTextColor, ps.hdc, hex_dm.active_char_text_color
		.else
			invoke SetBkColor,   ps.hdc, hex_dm.bk_color3
			invoke SetTextColor, ps.hdc, hex_dm.text_color3
		.endif
		invoke ExtTextOut, ps.hdc, offs_l, offs_t, ETO_OPAQUE, 0, esi, 1, 0
		inc    edi
		mov    eax, hex_dm.fon_cx
		add    offs_l, eax
		mov    ecx, hex_dm.rc3.right
		sub    ecx, eax
		.if offs_l > ecx
			mov eax, hex_dm.rc3.left
			mov offs_l, eax
			mov eax, hex_dm.fon_cy
			add offs_t, eax
		.endif
		dec    counter
		mov    eax, counter
		.if eax==0
			invoke SetBkColor, ps.hdc, hex_dm.bk_color3
			xor    edx, edx
			mov    eax, hex_dm.rc3.right
			sub    eax, offs_l
			div    hex_dm.fon_cx
			invoke ExtTextOut, ps.hdc, offs_l, offs_t, ETO_OPAQUE, 0, ADDR hexspace, eax, 0
		@fill_empty3:
			mov    ecx, hex_dm.rc3.bottom
			mov    eax, hex_dm.fon_cy
			add    offs_t, eax
			cmp    offs_t, ecx
			jge    @full3
			invoke ExtTextOut, ps.hdc, hex_dm.rc3.left, offs_t, ETO_OPAQUE, 0, ADDR hexspace, hex_dm.view_lenx, 0
			jmp    @fill_empty3
		@full3:
		.else
			mov    eax, hex_dm.rc3.bottom
			cmp    offs_t, eax
			jb @B
		.endif
		
		invoke SetBkColor,   ps.hdc, 0ffffffh
		invoke MemCopy, ADDR ps.rcPaint, ADDR rc, sizeof RECT
		mov    eax, hex_dm.rc3.right
		mov    rc.left, eax
		invoke ExtTextOut, ps.hdc, 0, 0, ETO_OPAQUE, ADDR rc, 0, 0, 0
		mov    eax, hex_dm.rc1.right
		mov    rc.left, eax
		add    eax, 4
		mov    rc.right, eax
		invoke ExtTextOut, ps.hdc, 0, 0, ETO_OPAQUE, ADDR rc, 0, 0, 0
		mov    eax, hex_dm.rc2.right
		mov    rc.left, eax
		add    eax, 4
		mov    rc.right, eax
		invoke ExtTextOut, ps.hdc, 0, 0, ETO_OPAQUE, ADDR rc, 0, 0, 0
		invoke MemCopy, ADDR ps.rcPaint, ADDR rc, sizeof RECT
		mov    eax, hex_dm.view_leny
		mul    hex_dm.fon_cy
		mov    rc.top, eax
		invoke ExtTextOut, ps.hdc, 0, 0, ETO_OPAQUE, ADDR rc, 0, 0, 0
		
		invoke EndPaint, hWin, ADDR ps
		
	.elseif eax==WM_ERASEBKGND
		mov eax, 1
		ret
		
	.elseif eax==WM_DESTROY
		invoke DeleteObject, dword ptr [lf_choose+ 0]
		invoke DeleteObject, dword ptr [lf_choose+ 4]
		invoke DeleteObject, dword ptr [lf_choose+ 8]
		invoke DestroyMenu,  hex_popup
		
	.else
		invoke DefWindowProc, hWin, uMsg, wParam, lParam
		ret
	.endif
	
	xor eax, eax
	ret

ShineInHexProc endp

to_UTF8 proc sour:DWORD,dest:DWORD
	LOCAL b1:BYTE
	LOCAL b2:BYTE
	
	xor    eax,eax
	mov    esi,sour
	mov    edi,dest
@@:
	mov    ax,word ptr [esi]
	;cmp    ax,0FFFFh
	;jg     _4bytes
	cmp    ax,0
	je     fin
	cmp    ax,07FFh
	jg     _3bytes
	cmp    ax,007Fh
	jg     _2bytes
	;----1_byte
	mov    byte ptr [edi],al
	inc    edi
	jmp    next_char
_2bytes:
	mov    ebx,080h
	mov    ecx,eax
	and    ecx,3Fh
	or     ecx,ebx
	mov    edx,ecx
	;---------------------
	mov    ebx,0C0h
	mov    ecx,eax
	shr    ecx,6
	or     ecx,ebx
	;---------------------
	mov    byte ptr [edi],cl
	mov    byte ptr [edi+1],dl
	add    edi,2
	jmp    next_char
_3bytes:
	mov    ebx,080h
	mov    ecx,eax
	and    ecx,3Fh
	or     ecx,ebx
	mov    b1,cl
	;--------------
	mov    ebx,080h
	mov    ecx,eax
	and    ecx,0FFFh
	shr    ecx,6
	or     ecx,ebx
	mov    b2,cl
	;--------------
	mov    ebx,0E0h
	mov    ecx,eax
	shr    ecx,12
	or     ecx,ebx
	;--------------
	mov    byte ptr [edi],cl
	mov    cl,b2
	mov    byte ptr [edi+1],cl
	mov    cl,b1
	mov    byte ptr [edi+2],cl
	add    edi,3
_4bytes: ;WE'LL_IGNORE_IT_AS_MOST_OF_API_DOES
next_char:
	add    esi,2
	jmp    @B
fin:
	mov    byte ptr [edi],0	
	
	ret

to_UTF8 endp

DlgFind proc hDlg:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	LOCAL buf1[512]:BYTE
	LOCAL buf2[512]:BYTE
	LOCAL tem[4]:BYTE
	LOCAl len:DWORD
	LOCAL count:DWORD

	mov    eax, uMsg
	.if eax == WM_INITDIALOG
		mov    hex_dm.checked,    1
		mov    hex_dm.found_offs, 0
		invoke CheckDlgButton, hDlg, 702, BST_CHECKED
	.elseif eax == WM_COMMAND
		mov    eax, wParam
		.if eax == 702
			mov    hex_dm.checked, 1
			invoke CheckDlgButton, hDlg, 702, BST_CHECKED
			invoke CheckDlgButton, hDlg, 703, BST_UNCHECKED
			invoke CheckDlgButton, hDlg, 704, BST_UNCHECKED		
		.elseif eax == 703
			mov    hex_dm.checked, 2
			invoke CheckDlgButton, hDlg, 703, BST_CHECKED		
			invoke CheckDlgButton, hDlg, 702, BST_UNCHECKED
			invoke CheckDlgButton, hDlg, 704, BST_UNCHECKED			
		.elseif eax == 704
			mov    hex_dm.checked, 3
			invoke CheckDlgButton, hDlg, 704, BST_CHECKED		
			invoke CheckDlgButton, hDlg, 702, BST_UNCHECKED
			invoke CheckDlgButton, hDlg, 703, BST_UNCHECKED
		.elseif eax == 706
			mov   eax, hex_dm.checked
			.if eax == 1
				invoke SendDlgItemMessageW, hDlg, 701, WM_GETTEXT, 512, ADDR buf1
				invoke to_UTF8, ADDR buf1, ADDR buf2
				invoke szLen, ADDR buf2
			.elseif eax == 2
				invoke SendDlgItemMessageW, hDlg, 701, WM_GETTEXT, 512, ADDR buf2
				invoke ucLen, ADDR buf2
				shl    eax, 1
			.elseif eax == 3
				invoke SendDlgItemMessage, hDlg, 701, WM_GETTEXT, 512, ADDR buf1
				mov    ecx, eax
				shr    ecx, 1
				shl    ecx, 1
				.if ecx != eax
					invoke MessageBox, hDlg, ADDR error_hex, 0, MB_OK
					ret
				.else
					mov    len, eax
					lea    edi, buf2
					mov    esi, 0
				@@:	
					invoke szMid, ADDR buf1, ADDR tem, esi, 2
					invoke htodw, ADDR tem
					mov    byte ptr [edi], al
					add    esi, 2
					inc    edi
					cmp    esi, len
					jb     @B
				.endif
				mov     eax, len
				shr     eax, 1
			.endif
			mov    len, eax	
			@@:	
			mov    ecx, len
			inc    ecx
			invoke BinSearch, hex_dm.found_offs, hex_dm.pointer, hex_dm._size, ADDR buf2, ecx
			.if eax == -1
				mov    ecx, hex_dm.found_offs
				mov    hex_dm.found_offs, 0			
				.if ecx > 0
					jmp @B
				.endif
				ret
			.endif
			mov    ecx, eax
			mov    hex_dm.found_offs, eax
			add    hex_dm.found_offs, 1
			add    ecx, len
			invoke SendMessage, hex_dm.hWnd, HEXM_SETSEL, eax, ecx
			;.endif
		.endif
	.elseif eax == WM_CLOSE
		invoke EndDialog, hDlg, 0
	.else
		xor    eax, eax
		ret
	.endif
	mov    eax, 1
	ret
DlgFind endp

DlgSelect proc hDlg:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	LOCAL s_offs[12]:BYTE
	LOCAL e_offs[12]:BYTE
	LOCAL S_OFFS:DWORD
	LOCAL E_OFFS:DWORD
	
	mov    eax, uMsg
	.if eax == WM_INITDIALOG
		
	.elseif eax == WM_COMMAND
		.if wParam == 805

			invoke SendDlgItemMessage, hDlg, 801, WM_GETTEXT, 9, ADDR s_offs
			invoke SendDlgItemMessage, hDlg, 802, WM_GETTEXT, 9, ADDR e_offs
			invoke htodw, ADDR s_offs
			mov    S_OFFS, eax
			invoke htodw, ADDR e_offs
			mov    E_OFFS, eax
			invoke SendMessage, hex_dm.hWnd, HEXM_SETSEL, S_OFFS, E_OFFS
			invoke EndDialog, hDlg, 0
		.endif
	.elseif eax == WM_CLOSE
		invoke EndDialog, hDlg, 0
	.else
		xor    eax, eax
		ret
	.endif
	mov    eax, 1
	ret
DlgSelect endp

End DllEntry
