fopen MACRO filename
	invoke CreateFile,reparg(filename),GENERIC_READ,
	FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL
	EXITM <eax>
ENDM

fopenW MACRO filename
	invoke CreateFile,reparg(filename),GENERIC_READ or GENERIC_WRITE,
	FILE_SHARE_READ,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL
	EXITM <eax>       ;; return file handle
ENDM

fclose MACRO arg:REQ
	invoke CloseHandle,arg
ENDM

fread MACRO hFile,buffer,bcnt
LOCAL var
	.data?
	var dd ?
	.code
	invoke ReadFile,hFile,buffer,bcnt,ADDR var,NULL
	mov eax, var
	EXITM <eax>
ENDM

fwrite MACRO hFile,buffer,bcnt
LOCAL var
	.data?
	var dd ?
	.code
	invoke WriteFile,hFile,buffer,bcnt,ADDR var,NULL
	mov eax, var
	EXITM <eax>
ENDM

CADD MACRO quoted_text:VARARG
LOCAL vname,lbl
	jmp lbl
	vname db quoted_text,0
	align 4
	lbl:
	EXITM <ADDR vname>
ENDM
      
FUNC MACRO parameters:VARARG
	invoke parameters
	EXITM <eax>
ENDM
      
literal MACRO quoted_text:VARARG
LOCAL local_text
	.data
	local_text db quoted_text,0
	align 4
	.code
	EXITM <local_text>
ENDM

CTXT MACRO quoted_text:VARARG
	EXITM <offset literal(quoted_text)>
ENDM

reparg	MACRO arg
LOCAL nustr
	quot SUBSTR <arg>,1,1
	IFIDN quot,<">
		.data
		nustr db arg,0
		.code
		EXITM <ADDR nustr>
	ELSE
		EXITM <arg>
	ENDIF
ENDM

; Conditional
; ----------------------------
; if	!eax	jmp @@
; ----------------------------
; IF ZERO
ifz	Macro	arg,reg
	IfNB	<reg>
	test	reg,reg
	Else
	test	eax,eax
	EndIf
	jz	arg
EndM

; ----------------------------
; if	eax	jmp @@
; ----------------------------
; IF NOT ZERO
ifnz	Macro	arg,reg
	IfNB	<reg>
	test	reg,reg
	Else
	test	eax,eax
	EndIf
	jnz	arg
endm

; ----------------------------
; if (eax == -1) jmp @@
; ----------------------------
; IF FALSE (-1)
iff macro arg:REQ
	inc	eax
	jz	arg
	dec	eax
endm

; ----------------------------
; if (eax == 1) jmp @@
; ----------------------------
; IF TRUE (1)
ift	Macro	arg,reg
	IfNB	<reg>
	dec	reg
	jz	arg
	inc	reg
	Else
	dec	eax
	jz	arg
	inc	eax
	EndIf
endm

; Mov memory to memory
m2m	Macro M1, M2
	push	M2
	pop	M1
EndM


ZeroMem	Macro	lpBuffer, nSize
	push	edi
	cld
	IfNB	<nSize>
		IfDifI	<&nSize>, <ecx>
		mov	ecx,nSize		; Size of buffer to fill
		EndIf
	EndIf
	IfDifI	<&lpBuffer>, <edi>
	mov	edi,lpBuffer		; Buffer address
	EndIf
	xor	eax, eax		; fill with 0
	
	push	edx
	mov	edx,ecx
	sar	ecx,2
	rep	stosd
	add	ecx,edx
	and	ecx,3
	rep	stosb
	pop	edx
	pop	edi
EndM

ZeroMemD	Macro	lpBuffer, nSize
	push	edi
	cld
	IfNB	<nSize>
		IfDifI	<&nSize>, <ecx>
		mov	ecx,nSize		; Size of buffer to fill
		EndIf
	EndIf
	IfDifI	<&lpBuffer>, <edi>
	mov	edi,lpBuffer		; Buffer address
	EndIf
	xor	eax, eax		; fill with 0
	rep	stosd
	pop	edi
EndM

;InitOFN	ofns,pFilebuff,dBuffsize,dOfnflags,pDlgtitle,pstrFilter,hwnd,hinst,pFiletitle,dMaxfiletitle,pstrInitdir,pDlgtitle
; Assumed that structure is filled with zero in case of first init
InitOFN	Macro	ofns,pFilebuff,dBuffsize,dOfnflags,pDlgtitle,pstrFilter,hwnd,hinst,pFiletitle,dMaxfiletitle,pstrInitdir;,pDlgtitle
	mov	ofns.OPENFILENAME.lStructSize,sizeof OPENFILENAME
	IfNB	<hwnd>
		;If	hwnd NE 0
		If ((OPATTR(hwnd)) AND 12h)
		m2m	ofns.OPENFILENAME.hwndOwner,hwnd
		EndIf
	EndIf
	IfNB	<hinst>
		If	hinst NE 0
		m2m	ofns.OPENFILENAME.hInstance,hinst
		EndIf
	Else
		IfDef	hInstance
		m2m	ofns.OPENFILENAME.hInstance,hInstance
		EndIf
	EndIf
	IfNB	<pstrFilter>
		;If	pstrFilter NE 0
		If ((OPATTR(pstrFilter)) AND 12h)
		mov	ofns.OPENFILENAME.lpstrFilter,pstrFilter
		EndIf
	EndIf
	mov	ofns.OPENFILENAME.lpstrFile,pFilebuff
	mov	ofns.OPENFILENAME.nMaxFile,dBuffsize
	IfNB	<pFiletitle>
		If	pFiletitle NE 0
		;Pointer to a buffer that receives the file name and extension (without path information) of the selected file. This member can be NULL.
		mov	ofns.OPENFILENAME.lpstrFileTitle,pFiletitle
		mov	ofns.OPENFILENAME.nMaxFileTitle,dMaxfiletitle
		EndIf
	EndIf
	IfNB	<pstrInitdir>
		If	((OPATTR(pstrInitdir)) AND 12h)
		mov	ofns.OPENFILENAME.lpstrInitialDir,pstrInitdir
		EndIf
	EndIf
	IfNB	<pDlgtitle>
		If ((OPATTR(pDlgtitle)) AND 12h)
		mov	ofns.OPENFILENAME.lpstrTitle,pDlgtitle
		EndIf
	EndIf
	IfNB	<dOfnflags>
		mov	ofns.OPENFILENAME.Flags,dOfnflags
	Else
		; Simple flags
		OFN_FLAGS_SIMPLE	equ	OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST or OFN_LONGNAMES or OFN_EXPLORER or OFN_HIDEREADONLY
		mov	ofns.OPENFILENAME.Flags,OFN_FLAGS_SIMPLE
	EndIf
EndM
